The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::FileWvIn Class Reference

STK audio file input class. More...

`#include <FileWvIn.h>`

Inheritance diagram for stk::FileWvIn:

## Public Member Functions
| FileWvIn (unsigned long chunkThreshold=1000000, unsigned long chunkSize=1024)
| Default constructor.
| FileWvIn (std::string fileName, bool raw=false, bool doNormalize=true, unsigned long chunkThreshold=1000000, unsigned long chunkSize=1024, bool doInt2FloatScaling=true)
| Overloaded constructor for file input.
| ~FileWvIn (void)
| Class destructor.
virtual void | openFile (std::string fileName, bool raw=false, bool doNormalize=true, bool doInt2FloatScaling=true)
| Open the specified file and load its data.
virtual void | closeFile (void)
| Close a file if one is open.
virtual void | reset (void)
| Clear outputs and reset time (file) pointer to zero.
virtual void | normalize (void)
| Normalize data to a maximum of +-1.0.
virtual void | normalize (StkFloat peak)
| Normalize data to a maximum of +-peak.
virtual unsigned long | getSize (void) const
| Return the file size in sample frames.
virtual StkFloat | getFileRate (void) const
| Return the input file sample rate in Hz (not the data read rate).
bool | isOpen (void)
| Query whether a file is open.
bool | isFinished (void) const
| Query whether reading is complete.
virtual void | setRate (StkFloat rate)
| Set the data read rate in samples. The rate can be negative.
virtual void | addTime (StkFloat time)
| Increment the read pointer by time samples.
void | setInterpolate (bool doInterpolate)
| Turn linear interpolation on/off.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed frame.
virtual StkFloat | tick (unsigned int channel=0)
| Compute a sample frame and return the specified `channel` value.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill the StkFrames object with computed sample frames, starting at the specified channel and return the same reference.
Public Member Functions inherited from stk::WvIn
unsigned int | channelsOut (void) const
| Return the number of audio channels in the data or stream.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last computed sample frame.
virtual StkFloat | tick (unsigned int channel=0)=0
| Compute one sample frame and return the specified `channel` value.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Fill the StkFrames object with computed sample frames, starting at the specified channel and return the same reference.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK audio file input class.

This class inherits from WvIn. It provides a "tick-level" interface to the FileRead class. It also provides variable-rate playback functionality. Audio file support is provided by the FileRead class. Linear interpolation is used for fractional read rates.

FileWvIn supports multi-channel data. It is important to distinguish the tick() method that computes a single frame (and returns only the specified sample of a multi-channel frame) from the overloaded one that takes an StkFrames object for multi-channel and/or multi-frame data.

FileWvIn will either load the entire content of an audio file into local memory or incrementally read file data from disk in chunks. This behavior is controlled by the optional constructor arguments chunkThreshold and chunkSize. File sizes greater than chunkThreshold (in sample frames) will be read incrementally in chunks of chunkSize each (also in sample frames).

For file data read completely into local memory, the doNormalize flag can be used to normalize all values with respect to the maximum absolute value of the data.

If the file data format is fixed point, the flag doInt2FloatScaling can be used to control whether the values are scaled with respect to the corresponding fixed-point maximum. For example, if reading 16-bit signed integers, the input values will be scaled by 1 / 32768.0. This scaling will not happen for floating-point file data formats.

When the file end is reached, subsequent calls to the tick() functions return zeros and isFinished() returns true.

See the FileRead class for a description of the supported audio file formats.

by Perry R. Cook and Gary P. Scavone, 1995–2021.

## Constructor & Destructor Documentation

## ◆ FileWvIn()

stk::FileWvIn::FileWvIn | ( | std::string | fileName,
|  | bool | raw = `false`,
|  | bool | doNormalize = `true`,
|  | unsigned long | chunkThreshold = `1000000`,
|  | unsigned long | chunkSize = `1024`,
|  | bool | doInt2FloatScaling = `true`
| ) |  |

Overloaded constructor for file input.

An StkError will be thrown if the file is not found, its format is unknown, or a read error occurs.

## Member Function Documentation

## ◆ openFile()

virtual void stk::FileWvIn::openFile | ( | std::string | fileName,
|  | bool | raw = `false`,
|  | bool | doNormalize = `true`,
|  | bool | doInt2FloatScaling = `true`
| ) |  |
| virtual

Open the specified file and load its data.

Data from a previously opened file will be overwritten by this function. An StkError will be thrown if the file is not found, its format is unknown, or a read error occurs. If the file length is less than the chunkThreshold limit and doNormalize is true, the file data will be normalized with respect to the maximum absolute value of the data. If the doInt2FloatScaling flag is true and the input data is fixed-point, a scaling will be applied with respect to the fixed-point limits.

Reimplemented in stk::FileLoop.

## ◆ normalize() [1/2]

virtual void stk::FileWvIn::normalize | ( | void |  | ) |
| virtual

Normalize data to a maximum of +-1.0.

This function has no effect when data is incrementally loaded from disk.

Reimplemented in stk::FileLoop.

## ◆ normalize() [2/2]

virtual void stk::FileWvIn::normalize | ( | StkFloat | peak | ) |
| virtual

Normalize data to a maximum of +-peak.

This function has no effect when data is incrementally loaded from disk.

Reimplemented in stk::FileLoop.

## ◆ getFileRate()

virtual StkFloat stk::FileWvIn::getFileRate | ( | void |  | ) | const
| inlinevirtual

Return the input file sample rate in Hz (not the data read rate).

WAV, SND, and AIF formatted files specify a sample rate in their headers. STK RAW files have a sample rate of 22050 Hz by definition. MAT-files are assumed to have a rate of 44100 Hz.

Reimplemented in stk::FileLoop.

112{ return data_.dataRate(); };
stk::StkFrames::dataRate
StkFloat dataRate(void) const
Return the sample rate associated with the StkFrames data.
Definition: Stk.h:433

## ◆ setRate()

virtual void stk::FileWvIn::setRate | ( | StkFloat | rate | ) |
| virtual

Set the data read rate in samples. The rate can be negative.

If the rate value is negative, the data is read in reverse order.

Reimplemented in stk::FileLoop.

## ◆ addTime()

virtual void stk::FileWvIn::addTime | ( | StkFloat | time | ) |
| virtual

Increment the read pointer by time samples.

Note that this function will not modify the interpolation flag status.

Reimplemented in stk::FileLoop.

## ◆ setInterpolate()

void stk::FileWvIn::setInterpolate | ( | bool | doInterpolate | ) |
| inline

Turn linear interpolation on/off.

Interpolation is automatically off when the read rate is an integer value. If interpolation is turned off for a fractional rate, the time index is truncated to an integer value.

139{ interpolate_ = doInterpolate; };

## ◆ lastOut()

StkFloat stk::FileWvIn::lastOut | ( | unsigned int | channel = `0` | ) |
| inline

Return the specified channel value of the last computed frame.

If no file is loaded, the returned value is 0.0. The `channel` argument must be less than the number of output channels, which can be determined with the channelsOut() function (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

See also
  lastFrame()

194{
195#if defined(_STK_DEBUG_)
196 if ( channel >= data_.channels() ) {
197 oStream_ << "FileWvIn::lastOut(): channel argument and soundfile data are incompatible!";
198 handleError( StkError::FUNCTION_ARGUMENT );
199 }
200#endif
201
202 if ( finished_ ) return 0.0;
203 return lastFrame_[channel];
204}
stk::StkFrames::channels
unsigned int channels(void) const
Return the number of channels represented by the data.
Definition: Stk.h:416
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [1/2]

virtual StkFloat stk::FileWvIn::tick | ( | unsigned int | channel = `0` | ) |
| virtual

Compute a sample frame and return the specified `channel` value.

For multi-channel files, use the lastFrame() function to get all values from the computed frame. If no file data is loaded, the returned value is 0.0. The `channel` argument must be less than the number of channels in the file data (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::WvIn.

Reimplemented in stk::FileLoop.

## ◆ tick() [2/2]

virtual StkFrames & stk::FileWvIn::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| virtual

Fill the StkFrames object with computed sample frames, starting at the specified channel and return the same reference.

The `channel` argument plus the number of input channels must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::WvIn.

Reimplemented in stk::FileLoop.

The documentation for this class was generated from the following file:

- FileWvIn.h

The Synthesis ToolKit in C++ (STK)
©1995--2021 Perry R. Cook and Gary P. Scavone. All Rights Reserved.